#!/bin/sh

##START LIST##
LISTE2="./upgrade/patch2.sh ./usr/local/drivers_V3.22/aic14.install ./usr/local/drivers_V3.22/aic14.o ./usr/local/drivers_V3.22/aud.install ./usr/local/drivers_V3.22/aud.o ./usr/local/drivers_V3.22/csi.o ./usr/local/drivers_V3.22/debug_kpp.o ./usr/local/drivers_V3.22/dmab.o ./usr/local/drivers_V3.22/doze.install ./usr/local/drivers_V3.22/doze.o ./usr/local/drivers_V3.22/emma_pp.o ./usr/local/drivers_V3.22/emma_prp.o ./usr/local/drivers_V3.22/framebuf.o ./usr/local/drivers_V3.22/ga_linuxdrv.o ./usr/local/drivers_V3.22/gpio.o ./usr/local/drivers_V3.22/hhwstrap.o ./usr/local/drivers_V3.22/hmp4d.o ./usr/local/drivers_V3.22/hmp4e.o ./usr/local/drivers_V3.22/i2c-aic14.o ./usr/local/drivers_V3.22/kpp.o ./usr/local/drivers_V3.22/lcd.o ./usr/local/drivers_V3.22/mx21_reg_proc.o ./usr/local/drivers_V3.22/run ./usr/local/drivers_V3.22/sensor.o ./usr/local/drivers_V3.22/smm.o ./usr/local/drivers_V3.22/spi.o ./usr/local/drivers_V3.22/systclk.install ./usr/local/drivers_V3.22/systclk.o ./usr/local/drivers_V3.22/tvlink.o ./usr/local/drivers_V3.22/watchdog.o ./usr/local/drivers_V3.22/wpa_supplicant ./usr/local/scripts_V3.22/config_ats.sh ./usr/local/scripts_V3.22/find_accesspoint.sh ./usr/local/scripts_V3.22/network.opts ./usr/local/scripts_V3.22/rc.local ./usr/local/scripts_V3.22/rc.splash ./usr/local/scripts_V3.22/S80emma ./usr/local/scripts_V3.22/S81hantro ./usr/local/scripts_V3.22/S99bgw211 ./usr/local/startup_V3.22/daemon.sh ./usr/local/startup_V3.22/netsyncd ./usr/local/startup_V3.22/update.bin ./usr/local/startup_V3.22/upgraded ./usr/local/startup_V3.22/upgrade*.cfg"
##END LIST##


##START VERSION##                                        | 
VERSION=V3.22
##END VERSION##   

# Get specific CONFIG_CODE for operator network
CONFIG_CODE=""
if test -f "/user_data/config_code.txt"
then
    CONFIG_CODE=`cat /user_data/config_code.txt`
fi

case $1 in
   #xxxxxxxxxxxxxxxxxxxxxxxx
   clear)
      
      /upgrade/backup/patch2.sh clear_old 2>/dev/null 1>&2
   ;;
   
   #xxxxxxxxxxxxxxxxxxxxxxxx
   clear_old)
   
    rm -rf /usr/local/drivers_$VERSION
    rm -rf /usr/local/scripts_$VERSION
    rm -rf /usr/local/startup_$VERSION

   ;;
   
   #xxxxxxxxxxxxxxxxxxxxxxxx
   restore)
   
    ln -fs /usr/local/drivers_$VERSION /usr/local/drivers
    ln -fs /usr/local/scripts_$VERSION /usr/local/scripts
    ln -fs /usr/local/startup_$VERSION /usr/local/startup
   ;;
   
   #xxxxxxxxxxxxxxxxxxxxxxxx
   update)
   
    ln -fs /usr/local/drivers_$VERSION /usr/local/drivers
    ln -fs /usr/local/scripts_$VERSION /usr/local/scripts
    ln -fs /usr/local/startup_$VERSION /usr/local/startup

    if [ "$CONFIG_CODE" = "FT" ]
      then
        #specific ugrade for FT
        cp -f /usr/local/startup/upgrade_ref_FT.cfg  /usr/local/startup/upgrade.cfg
    fi

    if [ "$CONFIG_CODE" = "KPN" ] 
      then
        #change specific upgrade CFG file
        cp -f /usr/local/startup/upgrade_ref_KPN.cfg  /usr/local/startup/upgrade.cfg
    fi

    if [ "$CONFIG_CODE" = "EFT1" ] || [ "$CONFIG_CODE" = "EFT2" ]
      then
        #change specific upgrade CFG file
        cp -f /usr/local/startup/upgrade_ref_EFT.cfg  /usr/local/startup/upgrade.cfg

    fi

   ;;

esac

echo 0 > /upgrade/pack.txt

exit 0
