#!/bin/sh
##START LIST##
LISTE6="./upgrade/patch6.sh ./usr/local/data/hmedia.cfg ./usr/local/data/hmedia_demo.cfg ./usr/local/data/hmedia_ref*.cfg ./usr/local/data/hpr0call_forward.cfg ./usr/local/data/hpr0call_services.cfg ./usr/local/data/hpr0call_services_ref*.cfg ./usr/local/data/hpr0userparam_ViewFinder_OoR.cfg ./usr/local/data/hpr0userparam.cfg ./usr/local/data/hpr0userparam_demo.cfg ./usr/local/data/hpr0userparam_ref*.cfg ./usr/local/data/hprv0param.cfg ./usr/local/data/hprv0param_ref*.cfg ./usr/local/data/hpw_config.txt ./usr/local/data/idletvpicture.bin ./usr/local/data/monitor*.cfg ./usr/local/data/*.conf ./usr/local/data/wifi_config_ref.txt ./usr/local/data/wpa_supplicant_ref.conf ./usr/local/data/demo/hmedia_demo.cfg ./usr/local/data/demo/hpr0userparam_demo.cfg ./usr/local/data/demo/iwconfig_demo ./usr/local/data/demo/wifi_config_demo.txt ./usr/local/data/mat/iwconfig_mat ./usr/local/data/mat/wifi_config_mat.txt ./usr/local/etc/default/*.conf ./usr/local/tmp/*"
##END LIST##

##START VERSION##                                        | 
VERSION=V3.22
##END VERSION##   

#script called for CONFIG_XXX
CONFIG_ATS=/usr/local/scripts/config_ats.sh

#==============================================================================
# getparameter of a ((file, parameter) normal format or (file parameter 1) string format var="value"
#==============================================================================
getparameter()
{
    file=$1
    parameter=$2
    if [ ! -f $file ]
    then
	eval "$parameter="
	return 
    fi
    if [ $# = 2 ]
    then
	value=`cat $file | awk -v par=$2 'match($1,par) == 1  {print $0};' | cut -f 2 -d'=' |sed 's/^ *//'`
    else
	value=`cat $file | awk -v par=$2 'match($1,par) == 1  {print $0};' | cut -f 2 -d'=' |sed 's/\"\([^\"]*\)\"/\1/'`
    fi
    eval "$parameter=$value"
}



#==============================================================================
# setparameter of a (file parameter value) normal format or (file parameter value 1) = string "" format
#=============================================================================
setparameter()
{
    file=$1
    parameter=$2
    value=$3
    
    cp -f $file /tmp/`basename $file`  
    if [  $# = 3 ]
    then
	cat /tmp/`basename $file` | sed -e "s/$parameter\=.*/$parameter\=$value/" > $file 
    else
	cat /tmp/`basename $file` | sed -e "s/$parameter\=.*/$parameter\=\"$value\"/" > $file 
    fi
    rm -f /tmp/`basename $file`
}

#==============================================================================
# removeparameter of a (file parameter) 
#=============================================================================
removeparameter()
{
    file=$1
    parameter=$2
    
    cp -f $file /tmp/`basename $file` 
    cat /tmp/`basename $file` | sed -e "s/$parameter\=.*//" > $file 
    rm -f /tmp/`basename $file`
}





case $1 in
   #xxxxxxxxxxxxxxxxxxxxxxxx
   clear)
   
   ;;

   #xxxxxxxxxxxxxxxxxxxxxxxx
   restore)
   
   ;;

   #xxxxxxxxxxxxxxxxxxxxxxxx
   update)
   
    FULLVERSION=`cat /user_settings/version.conf | grep P6 | awk '{print $3}'`
    MAJOR=`echo $FULLVERSION | cut -f1 -d"."`
    MINOR=`echo $FULLVERSION | cut -f2 -d"."`
    OLDVERSION=`echo $MAJOR$MINOR`
    FLAG_LANGUAGE = 0
    
    # Get specific CONFIG_CODE for operator network
    CONFIG_CODE=""
    if test -f "/user_data/config_code.txt"
        then
            CONFIG_CODE=`cat /user_data/config_code.txt`
    fi

    # Get previous version parameters if exist
    if test $OLDVERSION -ge 300
      then
        # Get SubscriptionDone parameter
        if [ -f /user_settings/RegistrationSettings.conf ]
          then
	    echo "Read subscriptionDone parameter value"
            subscriptionDone=`cat /user_settings/RegistrationSettings.conf | awk -v par=subscriptionDone  'match($1,par) == 1  {print $0};' | cut -f 2 -d'=' |sed 's/^ *//'`
	    echo "    Value of subscriptionDone is $subscriptionDone"
          fi  # Get SubscriptionDone parameter

        # Get selected Language parameter
        if [ -f /user_settings/locale.conf ]
            then
                FLAG_LANGUAGE=1
                echo "Read Selected Language in the previous version "
                PrevLanguage=`cat /user_settings/locale.conf | awk -v par=Language  'match($1,par) == 1  {print $0};' | cut -f 2 -d'=' |sed 's/^ *//'`
                echo "    Type of language is $PrevLanguage"
        fi # Get selected Language parameter

    fi  # Get previous version parameters if exist


    ########################
    ## patch version 1.21 ##
    ########################
    if test $OLDVERSION -lt 121
        then
	#echo moved to this position !!!
        echo 
        echo "Update of software version 1.21"
        echo     

            # Suppress file CallSettings.conf because new parameters for Call Forward are added
            rm -f /user_settings/CallSettings.conf         

            #update file /user_data/data/hpr0userparam.cfg for France Telecom Configuration
            if [ "$CONFIG_CODE" = "FT" ]
                then

                    sed s#^SIP_REGISTRAR_SERVER_PORT=.*#SIP_REGISTRAR_SERVER_PORT=5060#g /user_data/data/hpr0userparam.cfg > /user_data/data/hpr0userparam.cfg.1
                    mv /user_data/data/hpr0userparam.cfg.1 /user_data/data/hpr0userparam.cfg

                    sed s#^SIP_PROXY_SERVER_1=.*#SIP_PROXY_SERVER_1=172.20.193.209:5060#g /user_data/data/hpr0userparam.cfg > /user_data/data/hpr0userparam.cfg.1
                    mv /user_data/data/hpr0userparam.cfg.1 /user_data/data/hpr0userparam.cfg

                    sed s#^SIP_PORT=.*#SIP_PORT=5060#g /user_data/data/hpr0userparam.cfg > /user_data/data/hpr0userparam.cfg.1
                    mv /user_data/data/hpr0userparam.cfg.1 /user_data/data/hpr0userparam.cfg

                    sed s#^SIP_TCP_PORT=.*#SIP_TCP_PORT=#g /user_data/data/hpr0userparam.cfg > /user_data/data/hpr0userparam.cfg.1
                    mv /user_data/data/hpr0userparam.cfg.1 /user_data/data/hpr0userparam.cfg

                    sed s#^SIP_TCP_TLS_PORT=.*#SIP_TCP_TLS_PORT=#g /user_data/data/hpr0userparam.cfg > /user_data/data/hpr0userparam.cfg.1
                    mv /user_data/data/hpr0userparam.cfg.1 /user_data/data/hpr0userparam.cfg

                    sed s#^USER_AGENT=.*#USER_AGENT=VP6500#g /user_data/data/hpr0userparam.cfg > /user_data/data/hpr0userparam.cfg.1
                    mv /user_data/data/hpr0userparam.cfg.1 /user_data/data/hpr0userparam.cfg
                    
                    sed s#^MWI_ADDRESS=.*#MWI_ADDRESS=voicemail.sip.france.fr#g /user_data/data/hpr0userparam.cfg > /user_data/data/hpr0userparam.cfg.1
                    mv /user_data/data/hpr0userparam.cfg.1 /user_data/data/hpr0userparam.cfg                                                            
            fi
    fi

    ########################
    ## patch version 2.00 ##
    ########################
    if test $OLDVERSION -lt 200
        then
            echo 
            echo "Update of software version 2.00"
            echo       

            # Suppress unused field UPGRADE_ALLOWED in file hpr0userparam.cfg
            sed s#^UPGRADE_ALLOWED=.*##g /user_data/data/hpr0userparam.cfg > /user_data/data/hpr0userparam.cfg.1
            mv /user_data/data/hpr0userparam.cfg.1 /user_data/data/hpr0userparam.cfg

            # mise a jour de la mire de test
            cp -f /usr/local/tmp/tv_test_card1.bin /user_data/prod/data/tv_test_card1.bin

            # Mise  jour des fichiers pour le WiFi
            cp -f /usr/local/tmp/rf_tx.sh /user_data/prod/rf_tx.sh
            cp -f /usr/local/tmp/stop_test.sh /user_data/prod/stop_test.sh
            cp -f /usr/local/tmp/fast_ping /user_data/prod/bin/fast_ping
            cp -f /usr/local/tmp/pctitool /user_data/prod/bin/pctitool

            #Mise  jour des fichiers pour la gestion des batteries
            cp -f /usr/local/tmp/bat_cur_ChargIn.cfg /user_data/data/battery/bat_cur_ChargIn.cfg
            cp -f /usr/local/tmp/bat_cur_ChargOut.cfg /user_data/data/battery/bat_cur_ChargOut.cfg
            cp -f /usr/local/tmp/battery_current.cfg /user_data/data/battery/battery_current.cfg
            cp -f /usr/local/tmp/battery_dev_delta.cfg /user_data/data/battery/battery_dev_delta.cfg

    fi


    ########################
    ## patch version 2.01 ##
    ########################
    if test $OLDVERSION -lt 201
        then
            echo 
            echo "Update of software version 2.01"
            echo       

            # Suppress file PhoneProfile.conf because there are new settings
            rm -Rf /user_settings/PhoneProfile.conf            

            # Update file for Speed Dialing
            cp -f /usr/local/tmp/SpeedDial-FT.conf /usr/local/data/SpeedDial-FT.conf

            # Update file for Call Forward
            cp -f  /usr/local/tmp/hpr0call_forward.cfg /user_data/data/hpr0call_forward.cfg
            
            # Update file hprotal CFG file
            sed s#^STUN_SERVER_PORT=.*#STUN_SERVER_PORT=3478#g /user_data/data/hpr0userparam.cfg > /user_data/data/hpr0userparam.cfg.1

            echo "#
# CALL FORWARD PARAMETERS
#
CALL_FW_UNCONDITIONAL=1
CALL_FW_ON_BUSY=1
CALL_FW_NO_REPLY=1
CALL_FW_NO_REPLY_DELAY=20" >> /user_data/data/hpr0userparam.cfg.1
            mv /user_data/data/hpr0userparam.cfg.1 /user_data/data/hpr0userparam.cfg       


            #update file SpeedDial.conf for France Telecom Configuration
            if [ "$CONFIG_CODE" = "FT" ]
                then

                cd /usr/local/etc/default

                # save old file in /usr/local/data
                cp ./SpeedDial.conf /usr/local/data/SpeedDial.conf
                
                # suppress old files
                rm -Rf ./SpeedDial.conf
                rm -Rf /user_settings/SpeedDial.conf

                # create link on new file
                cp -f /usr/local/data/SpeedDial-FT.conf ./SpeedDial.conf

            fi

            #update file for KPN configuration
            if [ "$CONFIG_CODE" = "KPN" ]
                then

                sed s#^AUDIO_RTP_CHANNEL_DSCP=.*#AUDIO_RTP_CHANNEL_DSCP=0#g /user_data/data/hpr0userparam.cfg > /user_data/data/hpr0userparam.cfg.1
                mv /user_data/data/hpr0userparam.cfg.1 /user_data/data/hpr0userparam.cfg       

                sed s#^AUDIO_RTCP_CHANNEL_DSCP=.*#AUDIO_RTCP_CHANNEL_DSCP=0#g /user_data/data/hpr0userparam.cfg > /user_data/data/hpr0userparam.cfg.1
                mv /user_data/data/hpr0userparam.cfg.1 /user_data/data/hpr0userparam.cfg       

                sed s#^VIDEO_RTP_CHANNEL_DSCP=.*#VIDEO_RTP_CHANNEL_DSCP=0#g /user_data/data/hpr0userparam.cfg > /user_data/data/hpr0userparam.cfg.1
                mv /user_data/data/hpr0userparam.cfg.1 /user_data/data/hpr0userparam.cfg       

                sed s#^VIDEO_RTCP_CHANNEL_DSCP=.*#VIDEO_RTCP_CHANNEL_DSCP=0#g /user_data/data/hpr0userparam.cfg > /user_data/data/hpr0userparam.cfg.1
                mv /user_data/data/hpr0userparam.cfg.1 /user_data/data/hpr0userparam.cfg       

            fi


            #update files for EFT configuration
            if [ "$CONFIG_CODE" = "EFT" ]
                then

                sed s#^SIP_TCP_PORT=.*#SIP_TCP_PORT=#g /user_data/data/hpr0userparam.cfg > /user_data/data/hpr0userparam.cfg.1
                mv /user_data/data/hpr0userparam.cfg.1 /user_data/data/hpr0userparam.cfg       

                sed s#^SIP_TCP_TLS_PORT=.*#SIP_TCP_TLS_PORT=#g /user_data/data/hpr0userparam.cfg > /user_data/data/hpr0userparam.cfg.1
                mv /user_data/data/hpr0userparam.cfg.1 /user_data/data/hpr0userparam.cfg       

            fi

                            
    fi


    ########################
    ## patch version 2.02 ##
    ########################
    if test $OLDVERSION -lt 202
        then
            echo 
            echo "Update of software version 2.02"
            echo        

            # Update file wifi_config.txt
            cp -f /usr/local/tmp/wifi_config.txt /user_data/wifi/wifi_config.txt

            # Update file bat_cur_ChargIn.cfg, bat_cur_ChargOut.cfg, battery_current.cfg
            cp -f /usr/local/tmp/bat_cur_ChargIn.cfg /user_data/data/battery/bat_cur_ChargIn.cfg
            cp -f /usr/local/tmp/bat_cur_ChargOut.cfg /user_data/data/battery/bat_cur_ChargOut.cfg
            cp -f /usr/local/tmp/battery_current.cfg /user_data/data/battery/battery_current.cfg

            # Suppress RegistrationSettings Configuration file
            rm -f /user_settings/RegistrationSettings.conf

            # Change Configuration for FT
            if [ "$CONFIG_CODE" = "FT" ]
                then
                # Change Coddecs List priority for FT
                echo "Change Coddec List"
                sed s#^AUDIO_CODEC_PREFERENCE_LIST=.*#"AUDIO_CODEC_PREFERENCE_LIST=G711A G729_AB G711U"#g /user_data/data/hpr0userparam.cfg > /user_data/data/hpr0userparam.cfg.1
                mv /user_data/data/hpr0userparam.cfg.1 /user_data/data/hpr0userparam.cfg

                # Enable PRACK
                echo "Enable PRACK"
                sed s#^PRACK=.*#PRACK=1#g /user_data/data/hpr0userparam.cfg > /user_data/data/hpr0userparam.cfg.1
                mv /user_data/data/hpr0userparam.cfg.1 /user_data/data/hpr0userparam.cfg    
                fi
    fi

    ########################
    ## patch version 2.03 ##
    ########################
    if test $OLDVERSION -lt 203
        then
            echo 
            echo "Update of software version 2.03"
            echo        

            # Add Call Forward parameters for FT, KPN and EFT
            if [ "$CONFIG_CODE" = "FT" ] || [ "$CONFIG_CODE" = "EFT" ] || [ "$CONFIG_CODE" = "KPN" ]
                then
                # Add parameters for Call Forward
                echo "Add parameters for Call Forward"
                echo "#
# CALL FORWARD PARAMETERS
#
CALL_FW_UNCONDITIONAL=0
CALL_FW_ON_BUSY=0
CALL_FW_NO_REPLY=0
CALL_FW_NO_REPLY_DELAY=20" >> /user_data/data/hpr0userparam.cfg

            fi

            if [ "$CONFIG_CODE" = "FT" ] 
                then
                # Disable PRACK
                echo "Disable PRACK for FT configuration"
                sed s#^PRACK=.*#PRACK=0#g /user_data/data/hpr0userparam.cfg > /user_data/data/hpr0userparam.cfg.1
                mv /user_data/data/hpr0userparam.cfg.1 /user_data/data/hpr0userparam.cfg    
            fi

            # Add Call Forward configuration file 
            cp -f /usr/local/tmp/hpr0call_forward.cfg /usr/local/data/hpr0call_forward.cfg
            cd /user_data/data
            ln -s /usr/local/data/hpr0call_forward.cfg ./hpr0call_forward.cfg
            
            # Change Call Forward Parameters
            #echo "Change Call Forward Parameters"
            sed s#^CALL_FW_UNCONDITIONAL=.*#CALL_FW_UNCONDITIONAL=0#g /user_data/data/hpr0userparam.cfg > /user_data/data/hpr0userparam.cfg.1
            mv /user_data/data/hpr0userparam.cfg.1 /user_data/data/hpr0userparam.cfg
            sed s#^CALL_FW_ON_BUSY=.*#CALL_FW_ON_BUSY=0#g /user_data/data/hpr0userparam.cfg > /user_data/data/hpr0userparam.cfg.1
            mv /user_data/data/hpr0userparam.cfg.1 /user_data/data/hpr0userparam.cfg
            sed s#^CALL_FW_NO_REPLY=.*#CALL_FW_NO_REPLY=0#g /user_data/data/hpr0userparam.cfg > /user_data/data/hpr0userparam.cfg.1
            mv /user_data/data/hpr0userparam.cfg.1 /user_data/data/hpr0userparam.cfg
            sed s#^CALL_FW_NO_REPLY_DELAY=.*#CALL_FW_NO_REPLY_DELAY=20#g /user_data/data/hpr0userparam.cfg > /user_data/data/hpr0userparam.cfg.1
            mv /user_data/data/hpr0userparam.cfg.1 /user_data/data/hpr0userparam.cfg


            # Add parameter UPDATE_KEEP_ALIVE to hpr0userparam.cfg
            echo "Add parameter UPDATE_KEEP_ALIVE"
            echo "#
# Value of lifetime session timer
#
UPDATE_KEEP_ALIVE=0" >> /user_data/data/hpr0userparam.cfg
 
            # Suppress file wpa_supplicant_demo.conf
            rm -f /usr/local/data/demo/wpa_supplicant_demo.conf

            # Add Call Services configuration files
            echo "Add Call Services configuration files"
            cp -f /usr/local/tmp/hpr0CallServices*.cfg /usr/local/data
            cd /user_data/data
            rm -f ./hpr0CallServices.cfg
            ln -s /usr/local/data/hpr0CallServices_ref.cfg ./hpr0CallServices.cfg

            # Update file wifi_config.txt
            echo "Update file wifi_config.txt"

            sed s#^WIFI_THRESHOLD_TO_COME_BACK_IN_RANGE=.*#WIFI_THRESHOLD_TO_COME_BACK_IN_RANGE=5#g /user_data/wifi/wifi_config.txt > /user_data/wifi/wifi_config.txt.1
            mv /user_data/wifi/wifi_config.txt.1 /user_data/wifi/wifi_config.txt

    fi

    ########################
    ## patch version 2.04 ##
    ########################
    if test $OLDVERSION -lt 204
        then
            echo 
            echo "Update of software version 2.04"
            echo

            cd /user_data/data
            rm -f /user_data/data/hpr0CallServices.cfg

    fi

    ########################
    ## patch version 3.00 ##
    ########################
    if test $OLDVERSION -lt 300
        then
            echo 
            echo "Update of software version 3.00"
            echo

            # Read subscriptionDone parameter value
            echo "Read subscriptionDone parameter value"
            getparameter /user_settings/RegistrationSettings.conf subscriptionDone 
            echo "    Value of subscriptionDone is $subscriptionDone"

            # Delete MMI Configuration files
            echo "Delete MMI Configuration files"
            cd /usr/local/etc/default
            rm -Rf ./CallSettings.conf
            rm -Rf ./Security.conf
            rm -Rf ./Contacts.conf
            rm -Rf ./SpeedDial.conf
            rm -Rf ./EmergencyNumber.conf
            rm -Rf ./TvSettings.conf
            rm -Rf ./FontMap.conf
            rm -Rf ./customVido.conf
            rm -Rf ./IconSizes.conf
            rm -Rf ./locale.conf
            rm -Rf ./Phone.conf
            rm -Rf ./presstick.conf
            rm -Rf ./PhoneProfile.conf
            rm -Rf ./qpe.conf
            rm -Rf ./RegistrationSettings.conf
            rm -Rf ./speedtouch.conf
            rm -Rf ./sx55.conf
            
            # Create symbolic links of MMI Configuration files
            echo "Create symbolic links of MMI Configuration files"
            cd /usr/local/etc/default
            ln -s /usr/local/data/CallSettings_ref.conf ./CallSettings.conf
            ln -s /usr/local/data/Security.conf ./Security.conf
            ln -s /usr/local/data/Contacts.conf ./Contacts.conf
            ln -s /usr/local/data/SpeedDial_ref.conf ./SpeedDial.conf
            ln -s /usr/local/data/EmergencyNumber.conf ./EmergencyNumber.conf
            ln -s /usr/local/data/TvSettings.conf ./TvSettings.conf
            ln -s /usr/local/data/FontMap.conf ./FontMap.conf
            ln -s /usr/local/data/customVido.conf ./customVido.conf
            ln -s /usr/local/data/IconSizes.conf ./IconSizes.conf
            ln -s /usr/local/data/locale.conf ./locale.conf
            ln -s /usr/local/data/Phone.conf ./Phone.conf
            ln -s /usr/local/data/presstick.conf ./presstick.conf
            ln -s /usr/local/data/PhoneProfile.conf ./PhoneProfile.conf
            ln -s /usr/local/data/qpe.conf ./qpe.conf
            ln -s /usr/local/data/RegistrationSettings_ref.conf ./RegistrationSettings.conf
            ln -s /usr/local/data/speedtouch_ref.conf ./speedtouch.conf
            ln -s /usr/local/data/sx55_ref.conf ./sx55.conf

            # Delete file PhoneProfile.conf
            echo "Delete file /user_settings/PhoneProfile.conf"
            rm -f /user_settings/PhoneProfile.conf

            # Delete file CallSettings.conf
            echo "Delete file /user_settings/CallSettings.conf"
            rm -f /user_settings/CallSettings.conf
           
            # Delete files
            echo "Delete RegistrationSettings-FT.conf"
            rm -f /usr/local/data/RegistrationSettings-FT.conf
            echo "Delete SpeedDial-FT.conf"
            rm -f /usr/local/data/SpeedDial-FT.conf

            # Add new ATS file
            echo "Add new ATS file"
            cd /user_data/prod
            rm -f ./HC1_ats.sh
            rm -f ./HC1V00_ats.sh
            cp -f /usr/local/tmp/HC1_ats.sh ./HC1V00_ats.sh
            ln -s ./HC1V00_ats.sh ./HC1_ats.sh
            
            # Add new operator configuration file
            echo "Add new configuration file for operators"
            cd /user_data/prod
            ln -s $CONFIG_ATS ./config_ats.sh

            # Delete file hpr0call_forward.cfg
            echo "Delete file /user_data/data/hpr0call_forward.cfg"
            rm -f /user_data/data/hpr0call_forward.cfg

            # Delete old configuration files for Call Services
            echo "Delete old configuration files for Call Services"
            rm -f /usr/local/data/hpr0CallSer*.cfg
                        
            # Change value of CALL_FW_NO_REPLY_DELAY
            echo "Change value of CALL_FW_NO_REPLY_DELAY : 30 instead of 20"
            sed s#^CALL_FW_NO_REPLY_DELAY=.*#CALL_FW_NO_REPLY_DELAY=30#g /user_data/data/hpr0userparam.cfg > /user_data/data/hpr0userparam.cfg.1
            mv /user_data/data/hpr0userparam.cfg.1 /user_data/data/hpr0userparam.cfg

            # Add parameter for Automatic Dynamic media configuration
            echo "Add parameter for Automatic Dynamic media configuration"
            echo "#
#Automatic dynamic media configuration
#To enable this feature, static mode must be enabled
#	Enable=1
#	Disable=0
K_PR0_DYNAMIC_AUTO_MEDIA_SETTING=0" >> /user_data/data/hpr0userparam.cfg

            # Add parameter for Automatic media configuration
            echo "Add parameter for Automatic Static media configuration"
            echo "#Automatic media configuration
#	Enable=1
#	Disable=0
K_PR0_STATIC_AUTO_MEDIA_SETTING=0" >> /user_data/data/hpr0userparam.cfg

            # Add parameter to onvert * and # in escaped characters
            echo "Add parameter to convert * and # in escaped characters"
            echo "#
# Convert * and # in escaped characters if set to 1
# default value is disabled (0)
ESCAPE_STAR_CHARACTER=0
ESCAPE_HASH_CHARACTER=0" >> /user_data/data/hpr0userparam.cfg


            if [ "$CONFIG_CODE" = "KPN" ] 
            then
                # Change SIP_TCP_PORT
                echo "Change SIP_TCP_PORT"
                sed s#^SIP_TCP_PORT=.*#SIP_TCP_PORT=5060#g /user_data/data/hpr0userparam.cfg > /user_data/data/hpr0userparam.cfg.1
                mv /user_data/data/hpr0userparam.cfg.1 /user_data/data/hpr0userparam.cfg
                echo "Change SIP_TCP_TLS_PORT"
                sed s#^SIP_TCP_TLS_PORT=.*#SIP_TCP_TLS_PORT=5061#g /user_data/data/hpr0userparam.cfg > /user_data/data/hpr0userparam.cfg.1
                mv /user_data/data/hpr0userparam.cfg.1 /user_data/data/hpr0userparam.cfg                
            fi


    fi


    ########################
    ## patch version 3.02 ##
    ########################
    if test $OLDVERSION -lt 302
        then
            echo 
            echo "Update of software version 3.02"
            echo

            # Suppress charge beep file for KPN
            echo "Suppress charge beep file for KPN"
            cd /usr/local/sounds
            rm -f charge.KPN.wav
            rm -f charge.wav
            ln -s ./charge_ref.wav ./charge.wav


            # Suppress bad link on config_ats.sh file
            echo "Suppress bad link on config_ats.sh file"
            cd /user_data/prod
            rm -f config_ats.sh
            ln -s /usr/local/scripts/config_ats.sh ./config_ats.sh
    fi



    ########################
    ## patch version 3.10 ##
    ########################
    if test $OLDVERSION -lt 310
        then
            echo 
            echo "Update of software version 3.10"
            echo

            # Add some files for POS feature
            echo "Add some files for POS feature in user_data/home/Applications/addressbook"
            cp -f /usr/local/tmp/*.jpg /user_data/home/Applications/addressbook
            cp -f /usr/local/tmp/*.xml /user_data/home/Applications/addressbook

            # Change SNR for bargraph values
            echo "Change SNR for bargraph values in file /user_data/wifi/wifi_config.txt"
            cp -f /usr/local/tmp/wifi_config.txt /user_data/wifi


            # Add some parameters in file hpr0userparam.cfg
            if [ "$CONFIG_CODE" = "KPN" ] 
            then
                echo "Add parameter for whole uplink over IP configuration"
                echo "#whole uplink over IP in (128/256/384/512/768/1024) Kbps
ISP_IP_BIT_RATE=512" >> /user_data/data/hpr0userparam.cfg

                echo "Add parameter for Coefficient useful for uplink IP bandwidth in (0-100) %"
                echo "#Coefficient useful for uplink IP bandwidth in (0-100) %
COEF_OF_USEFUL_BANDWIDTH=50" >> /user_data/data/hpr0userparam.cfg

                echo "Add parameter for Option to manage 480 msg as 488"
                echo "#Option to manage 480 msg as 488
480_SWITCHES_CALL_TO_AUDIO=1" >> /user_data/data/hpr0userparam.cfg
            fi


            if [ "$CONFIG_CODE" = "FT" ] || [ "$CONFIG_CODE" = "" ]
            then
                echo "Add parameter for whole uplink over IP configuration"
                echo "#whole uplink over IP in (128/256/384/512/768/1024) Kbps
ISP_IP_BIT_RATE=256" >> /user_data/data/hpr0userparam.cfg

                echo "Add parameter for Coefficient useful for uplink IP bandwidth in (0-100) %"
                echo "#Coefficient useful for uplink IP bandwidth in (0-100) %
COEF_OF_USEFUL_BANDWIDTH=100" >> /user_data/data/hpr0userparam.cfg

                echo "Add parameter for Option to manage 480 msg as 488"
                echo "#Option to manage 480 msg as 488
480_SWITCHES_CALL_TO_AUDIO=0" >> /user_data/data/hpr0userparam.cfg
            fi



            if [ "$CONFIG_CODE" = "EFT1" ] || [ "$CONFIG_CODE" = "EFT" ]  || [ "$CONFIG_CODE" = "EFT1" ] || [ "$CONFIG_CODE" = "EFT2" ]  
            then
                echo "Add parameter for whole uplink over IP configuration"
                echo "#whole uplink over IP in (128/256/384/512/768/1024) Kbps
ISP_IP_BIT_RATE=128" >> /user_data/data/hpr0userparam.cfg

                echo "Add parameter for Coefficient useful for uplink IP bandwidth in (0-100) %"
                echo "#Coefficient useful for uplink IP bandwidth in (0-100) %
COEF_OF_USEFUL_BANDWIDTH=80" >> /user_data/data/hpr0userparam.cfg

                echo "Add parameter for Option to manage 480 msg as 488"
                echo "#Option to manage 480 msg as 488
480_SWITCHES_CALL_TO_AUDIO=0" >> /user_data/data/hpr0userparam.cfg
            fi




    fi



    ########################
    ## patch version 3.20 ##
    ########################
    if test $OLDVERSION -lt 320
        then
            echo 
            echo "Update of software version 3.20"
            echo

            # Add list of configuration scenari
            echo "Add list of configuration scenari in user_data"
            system cp -f /usr/local/tmp/config_code_list.txt /user_data/config_code_list.txt

            # Delete MMI Configuration files
            #echo "Delete MMI Configuration files"
            #cd /usr/local/etc/default
            #rm -Rf ./CallSettings.conf
            #rm -Rf ./Security.conf
            #rm -Rf ./Contacts.conf
            #rm -Rf ./SpeedDial.conf
            #rm -Rf ./EmergencyNumber.conf
            #rm -Rf ./TvSettings.conf
            #rm -Rf ./FontMap.conf
            #rm -Rf ./customVido.conf
            #rm -Rf ./IconSizes.conf
            #rm -Rf ./locale.conf
            #rm -Rf ./Phone.conf
            #rm -Rf ./presstick.conf
            #rm -Rf ./PhoneProfile.conf
            #rm -Rf ./qpe.conf
            #rm -Rf ./RegistrationSettings.conf
            #rm -Rf ./speedtouch.conf
            #rm -Rf ./sx55.conf
            
            # Create symbolic links of MMI Configuration files
            #echo "Create symbolic links of MMI Configuration files"
            #cd /usr/local/etc/default
            #ln -s /usr/local/data/CallSettings_ref.conf ./CallSettings.conf
            #ln -s /usr/local/data/Security.conf ./Security.conf
            #ln -s /usr/local/data/Contacts.conf ./Contacts.conf
            #ln -s /usr/local/data/SpeedDial_ref.conf ./SpeedDial.conf
            #ln -s /usr/local/data/EmergencyNumber.conf ./EmergencyNumber.conf
            #ln -s /usr/local/data/TvSettings.conf ./TvSettings.conf
            #ln -s /usr/local/data/FontMap.conf ./FontMap.conf
            #ln -s /usr/local/data/customVido.conf ./customVido.conf
            #ln -s /usr/local/data/IconSizes.conf ./IconSizes.conf
            #ln -s /usr/local/data/locale.conf ./locale.conf
            #ln -s /usr/local/data/Phone.conf ./Phone.conf
            #ln -s /usr/local/data/presstick.conf ./presstick.conf
            #ln -s /usr/local/data/PhoneProfile.conf ./PhoneProfile.conf
            #ln -s /usr/local/data/qpe.conf ./qpe.conf
            #ln -s /usr/local/data/RegistrationSettings_ref.conf ./RegistrationSettings.conf
            #ln -s /usr/local/data/speedtouch_ref.conf ./speedtouch.conf
            #ln -s /usr/local/data/sx55_ref.conf ./sx55.conf


    fi



    #clean old files
    rm -f /usr/local/tmp/*

    #update file except /user_data/data/hpr0userparam.cfg for KPN configuration
    if [ "$CONFIG_CODE" = "KPN" ]
    then
        $CONFIG_ATS CONFIG_KPN 1
    fi
    
    #update files except /user_data/data/hpr0userparam.cfg for France Telecom Configuration
    if [ "$CONFIG_CODE" = "FT" ]
    then
        $CONFIG_ATS CONFIG_FT 1
    fi
    
    #update file except /user_data/data/hpr0userparam.cfg for EFT1 configuration
    if [ "$CONFIG_CODE" = "EFT1" ]
    then
        $CONFIG_ATS CONFIG_EFT1 1
    fi

    #update file except /user_data/data/hpr0userparam.cfg for EFT2 configuration
    if [ "$CONFIG_CODE" = "EFT2" ]
    then
        $CONFIG_ATS CONFIG_EFT2 1
    fi


    if test $OLDVERSION -lt 300
        then
            # Update file RegistrationSettings.conf
            echo "        Copy file from /usr/local/etc/default/RegistrationSettings.conf"
            cp -f /usr/local/etc/default/RegistrationSettings.conf /user_settings/RegistrationSettings.conf

            echo "    Set to 1 subscriptionDone parameter value in RegistrationSettings.conf"
            sed s#^"subscriptionDone =.*"#"subscriptionDone = 1"#g  /user_settings/RegistrationSettings.conf > /user_settings/RegistrationSettings.conf.1
            mv /user_settings/RegistrationSettings.conf.1  /user_settings/RegistrationSettings.conf
    fi


    ######################################################################################
    ## Restore parameters from previous version  (used since version 3.00 )
    ## subscriptionDone parameter in RegistrationSettings.conf for version 3.00 ##
    ######################################################################################
    if test $OLDVERSION -ge 300  
        then
            if test $subscriptionDone -eq 1
            then
                echo 
                echo "Restore subscriptionDone parameter value in RegistrationSettings.conf"
                echo

                echo "    Copy file from /usr/local/etc/default/RegistrationSettings.conf"
                cp -f /usr/local/etc/default/RegistrationSettings.conf /user_settings/RegistrationSettings.conf

                echo "    Set parameter subscriptionDone to 1"
                sed s#^"subscriptionDone =.*"#"subscriptionDone = 1"#g  /user_settings/RegistrationSettings.conf > /user_settings/RegistrationSettings.conf.1
                mv /user_settings/RegistrationSettings.conf.1  /user_settings/RegistrationSettings.conf
            fi    #  $subscriptionDone

	    if [ "$FLAG_LANGUAGE" = "1" ]
            then
                echo 
                echo "Restore Language parameter value in Locale.conf"
                echo

                echo "    Copy file from /usr/local/etc/default/locale.conf"
                cp -f /usr/local/etc/default/locale.conf /user_settings/locale.conf

                echo "    Set language parameter to $PrevLanguage"
                sed s#^"Language =.*"#"Language = $PrevLanguage"#g  /user_settings/locale.conf > /user_settings/locale.conf.1
                mv /user_settings/locale.conf.1  /user_settings/locale.conf
            fi    #  test PrevLanguage

    fi     # test $OLDVERSION -ge 300 
    ;;
esac

echo 0 > /upgrade/pack.txt

exit 0
