#!/bin/bash

export PATH=$PATH:/root/bin

#================================================
# VARIABLES
#================================================
PROD_DIR="/user_data/prod"
#CONFIG_XXX handling
CONFIG_ATS=/usr/local/scripts/config_ats.sh

#--------------------------------
# - GPIO's
#--------------------------------
GPIO_PTA_DDIR=10015000
GPIO_PTA_OCR1=10015004
GPIO_PTA_OCR2=10015008
GPIO_PTA_DR=1001501C
GPIO_PTA_GIUS=10015020
GPIO_PTA_PUEN=10015040
GPIO_PTA_SSR=10015024

GPIO_PTB_DDIR=10015100
GPIO_PTB_OCR1=10015104
GPIO_PTB_OCR2=10015108
GPIO_PTB_DR=1001511C
GPIO_PTB_GIUS=10015120
GPIO_PTB_PUEN=10015140
GPIO_PTB_SSR=10015124

GPIO_PTC_DDIR=10015200
GPIO_PTC_OCR1=10015204
GPIO_PTC_OCR2=10015208
GPIO_PTC_DR=1001521C
GPIO_PTC_GIUS=10015220
GPIO_PTC_PUEN=10015240
GPIO_PTC_SSR=10015224

GPIO_PTD_DDIR=10015300
GPIO_PTD_OCR1=10015304
GPIO_PTD_OCR2=10015308
GPIO_PTD_DR=1001531C
GPIO_PTD_GIUS=10015320
GPIO_PTD_PUEN=10015340
GPIO_PTD_SSR=10015324

GPIO_PTE_DDIR=10015400
GPIO_PTE_OCR1=10015404
GPIO_PTE_OCR2=10015408
GPIO_PTE_DR=1001541C
GPIO_PTE_GIUS=10015420
GPIO_PTE_PUEN=10015440
GPIO_PTE_SSR=10015424


GPIO_PTF_DDIR=10015500
GPIO_PTF_OCR1=10015504
GPIO_PTF_OCR2=10015508
GPIO_PTF_DR=1001551C
GPIO_PTF_GIUS=10015520
GPIO_PTF_PUEN=10015540
GPIO_PTF_SSR=10015524

#--------------------------------
# - LCDC
#--------------------------------
LCDC_LSSAR=10021000

#--------------------------------
# - PRP
#--------------------------------
PRP_CNTL=10026400
PRP_DEST_RGB1_PTR=10026418
PRP_DEST_RGB2_PTR=1002641C
PRP_SOURCE_FRAME_SIZE=1002642C
PRP_CH1_LINE_STRIDE=10026430
PRP_CH1_OUT_IMAGE_SIZE=1002643C
PRP_SRC_PIXEL_FORMAT_CNTL=10026434
PRP_CH1_PIXEL_FORMAT_CNTL=10026438
PRP_CH2_OUT_IMAGE_SIZE=10026440
PRP_SOURCE_LINE_STRIDE=10026444
PRP_CSC_COEF_012=10026448
PRP_CSC_COEF_345=1002644C
PRP_CSC_COEF_678=10026450
PRP_CH1_RZ_HORI_COEF1=10026454
PRP_CH1_RZ_HORI_COEF2=10026458
PRP_CH1_RZ_HORI_VALID=1002645C
PRP_CH1_RZ_VERT_COEF1=10026460
PRP_CH1_RZ_VERT_COEF2=10026464
PRP_CH1_RZ_VERT_VALID=10026468

#================================================
# USEFULL CMD
#================================================
#--------------------------------
# - Mask return value
#--------------------------------
NO_TRACE()
{
   $* 2>/dev/null 1>&2
}
#--------------------------------
# - Get only hexa value
#--------------------------------
READ_REGISTER()
{
   mm -r $* | cut -d 'x' -f 3
}

#================================================
# AUDIO
#================================================
#--------------------------------
# - Audio loop
#--------------------------------
FUNC_AUDIO_LOOP_MAT()
{
   $PROD_DIR/bin/test_aic14 -sil -d /dev/dsp1 &
   usleep 30
   printf "DSP_SU3_SIT\n0x0001\n0x0800\n0x0800" > /proc/aud_dfl/dfl_param
   $PROD_DIR/bin/aic14_conf -w PSDO 0	      # OBIWAN
   $PROD_DIR/bin/aic14_conf -w ODRCT 3	      # OBIWAN
   $PROD_DIR/bin/aic14_conf -w DSTG   7       # sit: muted
   $PROD_DIR/bin/aic14_conf -w INBG   3       # mic: +24dB
   $PROD_DIR/bin/aic14_conf -w DAGAIN 0x25    # 
   $PROD_DIR/bin/aic14_conf -w ADGAIN 0x2F    # 
}
FUNC_AUDIO_LOOP_MTX()
{
   $PROD_DIR/bin/test_aic14 -loop &
   $PROD_DIR/bin/aic14_conf -w PSDO 0	      # OBIWAN
   $PROD_DIR/bin/aic14_conf -w ODRCT 3	      # OBIWAN
   $PROD_DIR/bin/aic14_conf -w DSTG   7       # sit: muted
   $PROD_DIR/bin/aic14_conf -w INBG   3       # mic: +24dB
   $PROD_DIR/bin/aic14_conf -w DAGAIN 0x25    # 
   $PROD_DIR/bin/aic14_conf -w ADGAIN 0x2F    #
}
#--------------------------------
# - Play key tone
#--------------------------------
FUNC_AUDIO_PLAY_KEY_TONE()
{
  $PROD_DIR/bin/test_aic14 -play_wav $PROD_DIR/data/sig1k.wav &
  $PROD_DIR/bin/aic14_conf -w PSDO 0	     # OBIWAN
  $PROD_DIR/bin/aic14_conf -w ODRCT 3	     # OBIWAN
  $PROD_DIR/bin/aic14_conf -w DSTG   7       # sit: muted
  $PROD_DIR/bin/aic14_conf -w DAGAIN 0x2A    # DAC:   0db
}
#--------------------------------
# - Play continuous tone
#--------------------------------
FUNC_AUDIO_PLAY_CONT_TONE_MTX()
{
   $PROD_DIR/bin/test_aic14 -play_wav $PROD_DIR/data/sig1k.wav -cont &
   $PROD_DIR/bin/aic14_conf -w PSDO 0	      # OBIWAN
   $PROD_DIR/bin/aic14_conf -w ODRCT 3	      # OBIWAN
   $PROD_DIR/bin/aic14_conf -w DSTG   7       # sit: muted
   $PROD_DIR/bin/aic14_conf -w DAGAIN 0x2A    # DAC:   0db
}
#--------------------------------
# - Play continuous tone
#--------------------------------
FUNC_AUDIO_PLAY_CONT_TONE_MAT()
{
   $PROD_DIR/bin/test_aic14 -d /dev/dsp1 -play_wav $PROD_DIR/data/sig1k.wav -cont &
   $PROD_DIR/bin/aic14_conf -w PSDO 0	      # OBIWAN
   $PROD_DIR/bin/aic14_conf -w ODRCT 3	      # OBIWAN
   $PROD_DIR/bin/aic14_conf -w DSTG   7       # sit: muted
   $PROD_DIR/bin/aic14_conf -w DAGAIN 0x2A    # DAC:   0db
}
#--------------------------------
# - Play stop
#--------------------------------
FUNC_AUDIO_STOP()
{
   NO_TRACE $PROD_DIR/bin/aic14_conf -w DLB    0       # loop back 
   NO_TRACE killall -9 test_aic14
   NO_TRACE [ $? -eq 0 ] && usleep 1
}
#--------------------------------
# OBIWAN - VIDEO_JACK:VIDEO(GPIO PE22=1)
#--------------------------------
FUNC_VIDEO_JACK_ON_VIDEO()
{
   NO_TRACE maskmmor $GPIO_PTE_DR 00400000 
}
#--------------------------------
# OBIWAN - VIDEO_JACK:AUDIO(GPIO PE22=0)
#--------------------------------
FUNC_VIDEO_JACK_ON_AUDIO()
{
   NO_TRACE maskmmand $GPIO_PTE_DR FFBFFFFF
}
#--------------------------------
# OBIWAN - Audio: HP on(GPIO PE02=1)
#--------------------------------
FUNC_HP_ON_MTX()
{
      NO_TRACE maskmmor $GPIO_PTE_DR 00000004
}
FUNC_HP_ON_MAT()
{
   $PROD_DIR/bin/aic14_conf -ampli ON
}
#--------------------------------
# OBIWAN - Audio path : HP off(GPIO PE02=0)
#--------------------------------
FUNC_HP_OFF_MTX()
{
      NO_TRACE maskmmand $GPIO_PTE_DR FFFFFFFB
}
FUNC_HP_OFF_MAT()
{
   $PROD_DIR/bin/aic14_conf -ampli OFF
}
#--------------------------------
# - Audio path : Activate Codec and apmlifier
#--------------------------------
FUNC_ACTIVATE_CODEC()
{
   echo "Warning: ATS function FUNC_ACTIVATE_CODEC() should not be called."
}
#--------------------------------
# - Headset path : headset to HP
#--------------------------------
FUNC_HEADSET_TO_HP()
{
   echo "Warning: function FUNC_HEADSET_TO_HP() should not be called"
}

#================================================
# OBIWAN LCD
#================================================
#--------------------------------
# - Switch display on LCD
#--------------------------------
FUNC_SWITCH_TO_LCD()
{
   NO_TRACE $PROD_DIR/bin/APPTvlink.exe <<-EOT
	6
	8
	EOT
}
#--------------------------------
# OBIWAN - Test card picture 1  LCD MIRE
#--------------------------------
FUNC_LCD_TEST_CARD_1()
{
   FUNC_SWITCH_TO_LCD;
   cp $PROD_DIR/data/lcd_test_card1.bin /dev/fb0
}
#--------------------------------
# OBIWAN- Test card picture 2  LCD GRIS
#--------------------------------
FUNC_LCD_TEST_CARD_2()
{
   FUNC_SWITCH_TO_LCD;
   cp $PROD_DIR/data/lcd_test_card2.bin /dev/fb0
}
#--------------------------------
# OBIWAN - Clear LCD display
#--------------------------------
FUNC_LCD_CLEAR()
{
   FB_START_ADDRESS=`READ_REGISTER $LCDC_LSSAR`
   mm -f $FB_START_ADDRESS 25800 0 
}
#--------------------------------
# OBIWAN - LCD backligth on(GPIO PE10=1 and PE5=0)
#--------------------------------
FUNC_LCD_BACKLIGTH_ON()
{
   NO_TRACE maskmmor $GPIO_PTE_DDIR 00000020
   NO_TRACE maskmmor $GPIO_PTE_GIUS 00000020
   NO_TRACE maskmmor $GPIO_PTE_OCR1 00000C00
   NO_TRACE maskmmand $GPIO_PTE_DR FFFFFFDF

   NO_TRACE maskmmor $GPIO_PTE_DR 00000400
}
#--------------------------------
# OBIWAN- LCD backligth off (GPIO PE10=0 and PE5=0)
#--------------------------------
FUNC_LCD_BACKLIGTH_OFF()
{
   NO_TRACE maskmmor $GPIO_PTE_DDIR 00000020
   NO_TRACE maskmmor $GPIO_PTE_GIUS 00000020
   NO_TRACE maskmmor $GPIO_PTE_OCR1 00000C00
   NO_TRACE maskmmor $GPIO_PTE_DR FFFFFFDF

   NO_TRACE maskmmand $GPIO_PTE_DR FFFFFBFF 
}
#--------------------------------
# OBIWAN - LCD PWM OFF(GPIO PE5 = 0)
#--------------------------------
FUNC_LCD_PWM_OFF()
{
   NO_TRACE maskmmor $GPIO_PTE_DDIR 00000020
   NO_TRACE maskmmor $GPIO_PTE_GIUS 00000020
   NO_TRACE maskmmor $GPIO_PTE_OCR1 00000C00
   NO_TRACE maskmmand $GPIO_PTE_DR FFFFFFDF
}
#--------------------------------
# OBIWAN- LCD PWM ON (GPIO PE5 = 1)
#--------------------------------
FUNC_LCD_PWM_ON()
{
   NO_TRACE maskmmor $GPIO_PTE_DDIR 00000020
   NO_TRACE maskmmor $GPIO_PTE_GIUS 00000020
   NO_TRACE maskmmor $GPIO_PTE_OCR1 00000C00
   NO_TRACE maskmmor $GPIO_PTE_DR 00000020
}

#================================================
# TV
#================================================
#--------------------------------
# - Switch display on TV
#--------------------------------
FUNC_SWITCH_TO_TV()
{
   NO_TRACE $PROD_DIR/bin/APPTvlink.exe <<-EOT
	6
	5
	1
	8
	EOT
   NO_TRACE maskmmor $GPIO_PTE_DR 00400000
}
#--------------------------------
# - Test card picture 1
#--------------------------------
FUNC_TV_TEST_CARD_1()
{
   FUNC_SWITCH_TO_TV;
   NO_TRACE cp $PROD_DIR/data/tv_test_card1.bin /dev/fb2
}

#--------------------------------
# - Test card blue
#--------------------------------
FUNC_TV_TEST_CARD_BLUE()
{
   FUNC_SWITCH_TO_TV;
      
   FB_START_ADDRESS=`READ_REGISTER $LCDC_LSSAR`

   NO_TRACE cp $PROD_DIR/data/tv_test_card_blue.bin /dev/fb2
}
#--------------------------------
# - Test card white
#--------------------------------
FUNC_TV_TEST_CARD_WHITE()
{
   FUNC_SWITCH_TO_TV;
      
   FB_START_ADDRESS=`READ_REGISTER $LCDC_LSSAR`
   mm -f2 $FB_START_ADDRESS 96000 80E8
}
#--------------------------------
# - Test card V TV difference with white measurement 
#--------------------------------
FUNC_TV_TEST_CARD_8020()
{
   FUNC_SWITCH_TO_TV;
      
   FB_START_ADDRESS=`READ_REGISTER $LCDC_LSSAR`
   mm -f2 $FB_START_ADDRESS 96000 8020
}

FUNC_TV_TEST_CARD_8040()
{
   FUNC_SWITCH_TO_TV;
      
   FB_START_ADDRESS=`READ_REGISTER $LCDC_LSSAR`
   mm -f2 $FB_START_ADDRESS 96000 8040
}
FUNC_TV_TEST_CARD_8060()
{
   FUNC_SWITCH_TO_TV;
      
   FB_START_ADDRESS=`READ_REGISTER $LCDC_LSSAR`
   mm -f2 $FB_START_ADDRESS 96000 8060
}
FUNC_TV_TEST_CARD_8080()
{
   FUNC_SWITCH_TO_TV;
      
   FB_START_ADDRESS=`READ_REGISTER $LCDC_LSSAR`
   mm -f2 $FB_START_ADDRESS 96000 8080
}
FUNC_TV_TEST_CARD_80a0()
{
   FUNC_SWITCH_TO_TV;
      
   FB_START_ADDRESS=`READ_REGISTER $LCDC_LSSAR`
   mm -f2 $FB_START_ADDRESS 96000 80a0
}
FUNC_TV_TEST_CARD_80c0()
{
   FUNC_SWITCH_TO_TV;
      
   FB_START_ADDRESS=`READ_REGISTER $LCDC_LSSAR`
   mm -f2 $FB_START_ADDRESS 96000 80c0
}

FUNC_TV_TEST_CARD_80E0()
{
   FUNC_SWITCH_TO_TV;
      
   FB_START_ADDRESS=`READ_REGISTER $LCDC_LSSAR`
   mm -f2 $FB_START_ADDRESS 96000 80E0
}

#--------------------------------
# OBIWAN - TV_27MHZ(GPIO PE23=01)
#--------------------------------
FUNC_TV_27MHZ_OFF()
{
   NO_TRACE maskmmor $GPIO_PTE_DR 00800000
}
#--------------------------------
# OBIWAN - TV_27MHZ(GPIO PE23=00)
#--------------------------------
FUNC_TV_27MHZ_ON()
{
   NO_TRACE maskmmand $GPIO_PTE_DR FF7FFFFF
}
#--------------------------------
# OBIWAN - ALIM_TV_LINK_OFF(GPIO PA24=01)
#--------------------------------
FUNC_ALIM_TV_LINK_OFF()
{
NO_TRACE maskmmor $GPIO_PTA_DR 01000000
}
#--------------------------------
# OBIWAN - ALIM_TV_LINK_ON(GPIO PA24=00)
#--------------------------------
FUNC_ALIM_TV_LINK_ON()
{
NO_TRACE maskmmand $GPIO_PTA_DR FEFFFFFF
}
#--------------------------------
# - Test card black
#--------------------------------
FUNC_TV_TEST_CARD_BLACK()
{
   FUNC_SWITCH_TO_TV;
      
   FB_START_ADDRESS=`READ_REGISTER $LCDC_LSSAR`
   mm -f2 $FB_START_ADDRESS 96000 8010
}
#--------------------------------
# - Stop TV test
#--------------------------------
FUNC_TV_TEST_STOP()
{
   echo "tv test 2"
   NO_TRACE maskmmand $GPIO_PTE_DR FFBFFFFF
}

#================================================
#  OBIWAN Viewfinder
#================================================
#--------------------------------
# - common settings
#--------------------------------
FUNC_PRP_COMMON_CFG()
{
   mm -w $PRP_CNTL 3234

   mm -w $PRP_SRC_PIXEL_FORMAT_CNTL 2CA00565
   mm -w $PRP_CH1_PIXEL_FORMAT_CNTL 2CA00565

   mm -w $PRP_CSC_COEF_012 09A2583A
   mm -w $PRP_CSC_COEF_345 0AE2A840
   mm -w $PRP_CSC_COEF_678 08035829

   mm -w $PRP_SOURCE_LINE_STRIDE 0
}
#--------------------------------
# OBIWAN - LCD settings
#--------------------------------
FUNC_VIEWFIND_ON_LCD()
{
   FUNC_PRP_COMMON_CFG;

   FUNC_SWITCH_TO_LCD;
   
   NO_TRACE killall -9 qpe
   FB_START_ADDRESS=`READ_REGISTER $LCDC_LSSAR`

   mm -w $PRP_DEST_RGB1_PTR $FB_START_ADDRESS
   mm -w $PRP_DEST_RGB2_PTR $FB_START_ADDRESS

   mm -w $PRP_SOURCE_FRAME_SIZE 01600120
   mm -w $PRP_CH1_OUT_IMAGE_SIZE 00B00090

   mm -w $PRP_CH1_LINE_STRIDE 1E0

   mm -w $PRP_CH1_RZ_HORI_COEF1 24
   mm -w $PRP_CH1_RZ_HORI_COEF2 0
   mm -w $PRP_CH1_RZ_HORI_VALID 02000002

   mm -w $PRP_CH1_RZ_VERT_COEF1 24
   mm -w $PRP_CH1_RZ_VERT_COEF2 0
   mm -w $PRP_CH1_RZ_VERT_VALID 02000002

   NO_TRACE $PROD_DIR/bin/APPSensor.exe <<-EOT
	1
	352
	288
	0
	0
	2
	6
	EOT

   mm -w $PRP_CNTL 2235 
}
#--------------------------------
# - TV settings
#--------------------------------
FUNC_VIEWFIND_ON_TV()
{
   NO_TRACE killall -9 qpe
   FUNC_PRP_COMMON_CFG;

   FUNC_SWITCH_TO_TV;

   FB_START_ADDRESS=`READ_REGISTER $LCDC_LSSAR`

   mm -w $PRP_DEST_RGB1_PTR $FB_START_ADDRESS
   mm -w $PRP_DEST_RGB2_PTR $FB_START_ADDRESS

   mm -w $PRP_SOURCE_FRAME_SIZE 028001E0
   mm -w $PRP_CH1_OUT_IMAGE_SIZE 028001E0

   mm -w $PRP_CH1_LINE_STRIDE 500

   mm -w $PRP_CH1_RZ_HORI_COEF1 7
   mm -w $PRP_CH1_RZ_HORI_COEF2 0
   mm -w $PRP_CH1_RZ_HORI_VALID 01000001

   mm -w $PRP_CH1_RZ_VERT_COEF1 7
   mm -w $PRP_CH1_RZ_VERT_COEF2 0
   mm -w $PRP_CH1_RZ_VERT_VALID 01000001

   NO_TRACE $PROD_DIR/bin/APPSensor.exe <<-EOT
	1
	640
	480
	0
	0
	2
	6
	EOT

   mm -w $PRP_CNTL 2235
   mm -w 80000000 d1171b12
}

FUNC_VIEWFIND_STOP()
{
   mm -w $PRP_CNTL 2234
}

#================================================
# KEYPAD
#================================================
#--------------------------------
# OBIWAN - keypad backligth on (GPIO PC18=1)
#--------------------------------
FUNC_KEYPAD_BACKLIGTH_ON()
{
   NO_TRACE maskmmor $GPIO_PTC_DR 00040000
 
}
#--------------------------------
# OBIWAN - keypad backligth off (GPIO PC18=0)
#--------------------------------
FUNC_KEYPAD_BACKLIGTH_OFF()
{
   NO_TRACE maskmmand $GPIO_PTC_DR FFFBFFFF
 
}

#================================================
# LED's
#================================================
#-------------------------------
# OBIWAN - led power off (GPIO PC27 = 0)
#-------------------------------
FUNC_LED_POWER_OFF()
{
   NO_TRACE maskmmand $GPIO_PTC_DR F7FFFFFF

}
#--------------------------------
# OBIWAN - led power on (GPIO PC27 = 1) (work only on charger)
#-------------------------------
FUNC_LED_POWER_ON()
{
   NO_TRACE maskmmor $GPIO_PTC_DR 08000000

}
#--------------------------------
# OBIWAN - on-air led on (GPIO PC29 = 1)
#--------------------------------
FUNC_LED_ON_AIR_ON()
{
   NO_TRACE maskmmor $GPIO_PTC_DR 20000000
}
#--------------------------------
# OBIWAN - on-air led off(GPIO PC29 = 0)
#--------------------------------
FUNC_LED_ON_AIR_OFF()
{
   NO_TRACE maskmmand $GPIO_PTC_DR DFFFFFFF
}
#--------------------------------
# OBIWAN - event led on (GPIO PC28 = 0)
#--------------------------------
FUNC_LED_EVENT_ON()
{
   NO_TRACE maskmmand $GPIO_PTC_DR EFFFFFFF
}
#--------------------------------
# OBIWAN - event led off (GPIO PC28 = 1)
#--------------------------------
FUNC_LED_EVENT_OFF()
{
   NO_TRACE maskmmor $GPIO_PTC_DR 10000000
}
#--------------------------------
# OBIWAN - CHARGE_INIT_ON (GPIO PC26 = 1)
#--------------------------------
FUNC_CHARGE_INIT_ON()
{
 
   NO_TRACE maskmmor $GPIO_PTC_DR 04000000
}
#--------------------------------
# OBIWAN - CHARGE_INIT_OFF (GPIO PC26 = 0)
#--------------------------------
FUNC_CHARGE_INIT_OFF()
{

   NO_TRACE maskmmand $GPIO_PTC_DR FBFFFFFF
}



#------------------------------------
# - Camera path : check camera
#------------------------------------
FUNC_CHECK_CAMERA()
{
    `echo 1 > /proc/gpio_mm/camera`
}



#================================================
# RADIO
#================================================
#-------------------------------
# - get mac address
#--------------------------------
FUNC_RADIO_GET_MAC_ADDRESS()
{
   case `head -n1 /var/run/stab | awk '{print $3}'` in
      "Marvell" ) NO_TRACE echo "Marvell module found";;
      "Agere" )  NO_TRACE echo "Agere module found" ;;
      * ) echo "Wifi module not found ...."
      exit 1;;
   esac

   eth_num=`tail -n1 /proc/net/wireless | awk '{print $1}'| cut -b4`
   mac_addr=`ifconfig eth$eth_num | grep HWaddr | cut -d" " -f11`
   printf "MAC: ${mac_addr}"
}
#--------------------------------
# - detect wifi manufacturer
#--------------------------------
FUNC_DETECT_MANUFACTURER()
{
   eth_num=`tail -n1 /proc/net/wireless | awk '{print $1}'| cut -b4`
   
   case `head -n1 /var/run/stab | awk '{print $3}'` in
     "Marvell" ) MANUFACTURER="Marvell" ;;
     "Agere" )  MANUFACTURER="Agere";;
     * ) echo "Wifi module not found ....";;
   esac 
}
#--------------------------------
# - Set Agere configuration
#--------------------------------
FUNC_AGERE_AD-HOC()
{                                                               
   cp /user_data/wifi/iwconfig-eth$eth_num /user_data/wifi/iwconfig-eth$eth_num.sav
   cp $PROD_DIR/data/iwconfig.adhoc_ch$ch_num /user_data/wifi/iwconfig-eth$eth_num

   ifconfig eth$eth_num down  
   sleep 2
   ifconfig eth$eth_num 1.1.1.1 up

   # if power failure, the previous file is restored
   mv /user_data/wifi/iwconfig-eth$eth_num.sav /user_data/wifi/iwconfig-eth$eth_num
} 
#--------------------------------
# - Set Marvell configuration
#--------------------------------
FUNC_MARVELL_AD-HOC()
{
   iwconfig eth$eth_num mode ad-hoc
   iwconfig eth$eth_num channel $ch_num
   /etc/marvell/wlanconfig eth$eth_num wrmac 0xa820 0x00000000
   /etc/marvell/wlanconfig eth$eth_num wrmac 0xa824 0x00080028
   /etc/marvell/wlanconfig eth$eth_num wrmac 0xa650 0x0
   /etc/marvell/wlanconfig eth$eth_num wrmac 0xa880 0x0
   /etc/marvell/wlanconfig eth$eth_num wrmac 0xa884 0x0400
   /etc/marvell/wlanconfig eth$eth_num wrmac 0xa88c 0x0000
   /etc/marvell/wlanconfig eth$eth_num wrmac 0xa88c 0x0003
}
#--------------------------------
# - Set module configuration
#--------------------------------
FUNC_CONFIGURE_MODULE()
{
   #deactivate DHCPCD
   NO_TRACE dhcpcd eth$eth_num -k
   
   #need to reboot application
   NO_TRACE killall -9 qpe

   case $MANUFACTURER in
     "Marvell" ) FUNC_MARVELL_AD-HOC ;;
     "Agere" )  FUNC_AGERE_AD-HOC;;
     * ) echo "Manufacturer error....";;
   esac
}
#--------------------------------
# - Send packets on channel 5
#--------------------------------
FUNC_RADIO_TX_PACKET_CHANNEL5()
{
   ch_num="5"
   
   FUNC_DETECT_MANUFACTURER; 
   
   FUNC_CONFIGURE_MODULE;
}
#--------------------------------
# - Send packets on channel 10
#--------------------------------
FUNC_RADIO_TX_PACKET_CHANNEL10()
{
   ch_num="10"

   FUNC_DETECT_MANUFACTURER;
   
   FUNC_CONFIGURE_MODULE;
}

#--------------------------------
# - Send packets on channel 5
#--------------------------------
FUNC_OBIWAN_WRITE_BGW211_EEPROM()
{
   dhcpcd -k
   killall wpa_supplicant
   ifconfig eth0 down
   sleep 1
   /user_data/prod/./eeprom_update.sh -c /user_data/prod/data/pce_eeprom.txt
}



#================================================
# MISC
#================================================
#--------------------------------
# - Read productstrap
#--------------------------------
FUNC_RETURN_PRODUCT_STRAP()
{
   # print out strap PE6 value, in ASCII format
   cat /proc/hhwstrap | cut -d ' ' -f 3 - | cut -b 1 -
}
#--------------------------------
# - OBIWAN_Read hardware strap
#--------------------------------
FUNC_RETURN_HARD_STRAP()
{
   # print out PCB ID straps, in ASCII format 
   # it can be read from /proc/hhswtrap, 3rd field.
   cat /proc/hhwstrap | cut -d ' ' -f 3 -
}
#--------------------------------
# - Read start mode status
#--------------------------------
FUNC_START_MODE()
{
   NO_TRACE maskmmand $GPIO_PTC_DDIR  FFFF7FFF
   NO_TRACE maskmmor $GPIO_PTC_GIUS  00008000
   NO_TRACE maskmmand 1001520C 7FFFFFFF
   
   readbit $GPIO_PTC_SSR 15
}
#--------------------------------
# - config port B
#--------------------------------
FUNC_CONFIG_PTB()
{
   NO_TRACE mm -w 10015100 08008040 # PTB_DDIR  
   NO_TRACE mm -w 10015120 EFC003F0 # PTB_GIUS  
   NO_TRACE mm -w 10015140 9FBFFE5F # PTB_PUEN  
   NO_TRACE mm -w 1001511C 08000080 # PTB_DR
   NO_TRACE mm -w 10015138 18000040 # PTB_GPR
}


#--------------------------------
# OBIWAN - read ACCESSORY DETECT (GPIO PE0)
#--------------------------------
FUNC_READ_ACCESSORY_DETECT()
{
    readbit 10015424 0
}
#--------------------------------
# OBIWAN - read ACCESSORY TYPE_1(GPIO PE1)
#--------------------------------
FUNC_READ_ACCESSORY_TYPE_1()
{
   NO_TRACE maskmmand $GPIO_PTE_DR FFFFFEFF	#PE8 accessory detect= 0

   readbit 10015424 1
}
#--------------------------------
# OBIWAN - ACCESSORY TYPE_2(GPIO PE1)
#--------------------------------
FUNC_ACCESSORY_TYPE_2()
{
 NO_TRACE maskmmor $GPIO_PTE_DR 00000100	#PE8 accessory detect= 1

}


#--------------------------------
# OBIWAN - read port p_fail (GPIO PB8)
#--------------------------------
FUNC_READ_PFAIL()
{
   #FUNC_CONFIG_PTB;
   readbit 10015124 8
}
#--------------------------------
# OBIWAN - read port charge_in(GPIO PB5)
#--------------------------------
FUNC_READ_CHARGE_IN()
{
   #FUNC_CONFIG_PTB;
   readbit 10015124 5
}
#--------------------------------
# OBIWAN - read port charge_STATUS(GPIO PB4)
#--------------------------------
FUNC_READ_CHARGE_STATUS()
{
   #FUNC_CONFIG_PTB;
   maskmmor 10015140 0000010
   readbit 10015124 4
}
#--------------------------------
# OBIWAN- read port LOW_BAT(GPIO PB9)
#--------------------------------
FUNC_READ_LOW_BAT()
{
   #FUNC_CONFIG_PTB;
   readbit 10015124 9
}
#--------------------------------
# OBIWAN- read port CAMERA_POS_DETECT(GPIO PB22)
#--------------------------------
FUNC_READ_CAMERA_POS_DETECT()
{
   #FUNC_CONFIG_PTB;
   readbit 10015124 22
}
#--------------------------------
# - calcul the product passwd
#--------------------------------
FUNC_CALCULATE_PASSWD()
{
   if [ -e /user_data/prod/pn_number.txt ]; then
      PN_NUMBER=`cat /user_data/prod/pn_number.txt`
   else  
      PN_NUMBER="unknown"
   fi

    if [ -e /user_data/data/macaddress.cfg ]; then
	MAC_ADDR=`cat /user_data/data/macaddress.cfg |awk '{a = $1; print sprintf("%s:%s:%s:%s:%s:%s",substr(a,1,2),substr(a,3,2),substr(a,5,2),substr(a,7,2),substr(a,9,2),substr(a,11,2));}'`
    else  
	MAC_ADDR="unknown"
   fi
   /user_data/prod/bin/pwdcalculation_arm $MAC_ADDR $PN_NUMBER
}

#--------------------------------
# - production tests on MTX
#--------------------------------
FUNC_TX_CW_CH10_1MBPS()
{
   /user_data/prod/rf_tx.sh
}

#--------------------------------
# - stop production tests on MTX
#--------------------------------
FUNC_STOP_FW_MMC()
{
   /user_data/prod/bin/pctitool eth0 18 255
}

#--------------------------------
# - called on MAT key 1
#--------------------------------
FUNC_TX_FAST_PING_1MBPS()
{
  /usr/local/scripts/mat_wifi_test.sh
}



#================================================
# [SCENARI]
#================================================
case $1 in
   #xxxxxxxxxxxxxxxxxxxxxxxx
   OBIWAN_AUDIO_LOOP)                 # MTX config.
      FUNC_AUDIO_STOP;
      FUNC_AUDIO_LOOP_MTX;
   ;;

   OBIWAN_AUDIO_PLAY_KEY_TONE)        # MTX config
      FUNC_AUDIO_STOP;
      FUNC_HP_ON_MTX;
      FUNC_AUDIO_PLAY_KEY_TONE;
   ;;

   OBIWAN_AUDIO_PLAY_CONT_TONE)       # MTX config
      FUNC_AUDIO_STOP;
      FUNC_HP_ON_MTX;
      FUNC_AUDIO_PLAY_CONT_TONE_MTX;
   ;;

   OBIWAN_AUDIO_STOP)                 # MTX & MAT config
      FUNC_AUDIO_STOP;
   ;;

   OBIWAN_HP_OFF)                     # OBIWAN MTX and MAT config
      FUNC_HP_OFF_MTX;
   ;;

   OBIWAN_HP_ON)                      # OBIWAN MTX and MAT config
      FUNC_HP_ON_MTX;
   ;;

   OBIWAN_VIDEO_JACK_ON_VIDEO)                # OBIWAN MTX and MAT config
      FUNC_VIDEO_JACK_ON_VIDEO;
   ;;
   
   OBIWAN_VIDEO_JACK_ON_AUDIO)              # OBIWAN MTX and MAT config
      FUNC_VIDEO_JACK_ON_AUDIO;
   ;; 

   #xxxxxxxxxxxxxxxxxxxxxxxx
   SWITCH_TO_LCD)
      FUNC_SWITCH_TO_LCD;
   ;;
   
   OBIWAN_LCD_TEST_CARD_1)
      FUNC_LCD_TEST_CARD_1;
   ;;

   OBIWAN_LCD_TEST_CARD_2)
      FUNC_LCD_TEST_CARD_2;
   ;;

   OBIWAN_LCD_CLEAR)
      FUNC_LCD_CLEAR;
   ;;

   OBIWAN_LCD_BACKLIGTH_ON)		            # OBIWAN MTX
      FUNC_LCD_BACKLIGTH_ON;
   ;;

   OBIWAN_LCD_BACKLIGTH_OFF)		            # OBIWAN MTX
      FUNC_LCD_BACKLIGTH_OFF;
   ;;

   OBIWAN_LCD_PWM_ON)			            # OBIWAN MTX
      FUNC_LCD_PWM_ON;
   ;;

   OBIWAN_LCD_PWM_OFF)		 	           # OBIWAN MTX
      FUNC_LCD_PWM_OFF;
   ;;

   #xxxxxxxxxxxxxxxxxxxxxxxx
   OBIWAN_SWITCH_TO_TV)
      FUNC_ALIM_TV_LINK_ON;
      FUNC_TV_27MHZ_ON;
      FUNC_SWITCH_TO_TV;
   ;;

   TV_TEST_CARD_1)
      FUNC_TV_TEST_CARD_1;
   ;;

   TV_TEST_CARD_BLUE)
      FUNC_TV_TEST_CARD_BLUE;
   ;;
   
   OBIWAN_TV_TEST_CARD_BLACK)
      FUNC_TV_TEST_CARD_BLACK;
   ;;

     OBIWAN_TV_TEST_CARD_8080)
      FUNC_TV_TEST_CARD_8080;
   ;;

     OBIWAN_TV_TEST_CARD_8020)
      FUNC_TV_TEST_CARD_8020;
   ;;

   OBIWAN_TV_TEST_CARD_80a0)
      FUNC_TV_TEST_CARD_80a0;
   ;;

   OBIWAN_TV_TEST_CARD_WHITE)
      FUNC_TV_TEST_CARD_WHITE;
   ;;

   OBIWAN_TV_TEST_CARD_8060)
      FUNC_TV_TEST_CARD_8060;
   ;;

   OBIWAN_TV_TEST_CARD_80e0)
      FUNC_TV_TEST_CARD_80E0;
   ;;

   OBIWAN_TV_TEST_CARD_8040)
      FUNC_TV_TEST_CARD_8040;
   ;;


   OBIWAN_TV_TEST_CARD_80c0)
      FUNC_TV_TEST_CARD_80c0;
   ;;


   OBIWAN_TV_27MHZ_OFF)
      FUNC_TV_27MHZ_OFF;
   ;;

   OBIWAN_TV_27MHZ_ON)
      FUNC_TV_27MHZ_ON;
   ;;

   OBIWAN_ALIM_TV_LINK_OFF)
      FUNC_ALIM_TV_LINK_OFF;
   ;;

   OBIWAN_ALIM_TV_LINK_ON)
      FUNC_ALIM_TV_LINK_ON;
   ;;

   #xxxxxxxxxxxxxxxxxxxxxxxx
   OBIWAN_VIEWFIND_ON_LCD)
      FUNC_LCD_BACKLIGTH_ON;
      FUNC_VIEWFIND_ON_LCD;
   ;;

   VIEWFIND_ON_TV)
      FUNC_ALIM_TV_LINK_ON;
      FUNC_TV_27MHZ_ON;
      FUNC_VIEWFIND_ON_TV;
   ;;

   OBIWAN_VIEWFIND_STOP)
      FUNC_VIEWFIND_STOP;
   ;;

   #xxxxxxxxxxxxxxxxxxxxxxxx
   OBIWAN_KEYPAD_BACKLIGTH_ON)		 # OBIWAN MTX
      FUNC_KEYPAD_BACKLIGTH_ON;
   ;;

   OBIWAN_KEYPAD_BACKLIGTH_OFF)		 # OBIWAN MTX
      FUNC_KEYPAD_BACKLIGTH_OFF;
   ;;
   
   OBIWAN_LED_POWER_OFF)		 # OBIWAN MTX
      FUNC_LED_POWER_OFF;
   ;;
   
   OBIWAN_LED_POWER_ON)	 		# OBIWAN MTX
      FUNC_LED_POWER_ON;
   ;;

   OBIWAN_LED_ON_AIR_ON)		 # OBIWAN MTX
      FUNC_LED_ON_AIR_ON;
   ;;
	
   OBIWAN_LED_ON_AIR_OFF)		 # OBIWAN MTX
      FUNC_LED_ON_AIR_OFF;
   ;;

   OBIWAN_LED_EVENT_ON)			 # OBIWAN MTX
      FUNC_LED_EVENT_ON;
   ;;

   OBIWAN_LED_EVENT_OFF)		 # OBIWAN MTX
      FUNC_LED_EVENT_OFF;
   ;;

   OBIWAN_CHARGE_INIT_ON)		 # OBIWAN MTX
      FUNC_CHARGE_INIT_ON;
   ;;

   OBIWAN_CHARGE_INIT_OFF)		 # OBIWAN MTX
      FUNC_CHARGE_INIT_OFF;
   ;;

   OBIWAN_READ_PFAIL)			# OBIWAN MTX
      FUNC_READ_PFAIL;
   ;;
   OBIWAN_READ_CHARGE_IN)		# OBIWAN MTX
	  FUNC_READ_CHARGE_IN;
   ;;
   OBIWAN_READ_CHARGE_STATUS)		# OBIWAN MTX
	  FUNC_READ_CHARGE_STATUS;
   ;;
   OBIWAN_READ_LOW_BAT)			# OBIWAN MTX
	  FUNC_READ_LOW_BAT;  
   ;;

   OBIWAN_READ_CAMERA_POS_DETECT)	# OBIWAN MTX
	  FUNC_READ_CAMERA_POS_DETECT;  
   ;;

  OBIWAN_READ_ACCESSORY_DETECT)	# OBIWAN MTX
	  FUNC_READ_ACCESSORY_DETECT;  
   ;;

   OBIWAN_READ_ACCESSORY_TYPE_1)	# OBIWAN MTX
	 FUNC_READ_ACCESSORY_TYPE_1;  
   ;;

   OBIWAN_ACCESSORY_TYPE_2)		# OBIWAN MTX
	 FUNC_ACCESSORY_TYPE_2;  
   ;;


   OBIWAN_RETURN_PRODUCT_STRAP)
      FUNC_RETURN_PRODUCT_STRAP;
   ;;


   OBIWAN_FUNC_CHECK_CAMERA)
      FUNC_CHECK_CAMERA;
   ;;

   RETURN_HARD_STRAP)
      FUNC_RETURN_HARD_STRAP;
   ;;

 
   #xxxxxxxxxxxxxxxxxxxxxxxx
   RADIO_GET_MAC_ADDRESS)
      FUNC_RADIO_GET_MAC_ADDRESS;
      printf "\n"
   ;;
   
   RADIO_TX_PACKET_CHANNEL5)
      FUNC_RADIO_TX_PACKET_CHANNEL5;
   ;;

   RADIO_TX_PACKET_CHANNEL10)
      FUNC_RADIO_TX_PACKET_CHANNEL10;
   ;;

   OBIWAN_WRITE_BGW211_EEPROM)
      FUNC_OBIWAN_WRITE_BGW211_EEPROM;
   ;;

   #xxxxxxxxxxxxxxxxxxxxxxxx
   OBIWAN_GET_SW_VERSION)
      cat /usr/local/sw_version.txt
   ;;

   GET_HW_VERSION)
      cat /proc/hhwstrap | cut -d ' ' -f 1 -
   ;;

   #xxxxxxxxxxxxxxxxxxxxxxxx
   CALCULATE_PASSWD)
      FUNC_CALCULATE_PASSWD;
   ;;
   
   #xxxxxxxxxxxxxxxxxxxxxxxx
   MAT_ENTRY_SEQ)               # MAT config
      FUNC_VIEWFIND_STOP;
      FUNC_AUDIO_STOP;
      FUNC_LCD_BACKLIGTH_ON;
      FUNC_KEYPAD_BACKLIGTH_ON;
      FUNC_LCD_TEST_CARD_1;      
      FUNC_HP_ON_MAT;
      FUNC_AUDIO_PLAY_CONT_TONE_MAT;
   ;;
   
   MAT_KEY_CAM_LCD)
      FUNC_VIEWFIND_STOP;
      FUNC_AUDIO_STOP;
      FUNC_LCD_BACKLIGTH_ON;
      FUNC_KEYPAD_BACKLIGTH_ON;
      FUNC_LED_ON_AIR_ON;
      FUNC_VIEWFIND_ON_LCD;
   ;;

   MAT_KEY_CAM_TV)
      FUNC_VIEWFIND_STOP;
      FUNC_AUDIO_STOP;
      FUNC_LCD_BACKLIGTH_ON;
      FUNC_KEYPAD_BACKLIGTH_ON;
      FUNC_LED_ON_AIR_ON;
      FUNC_VIEWFIND_ON_TV;
   ;;
   
      MAT_KEY_OK_LCD)
      FUNC_VIEWFIND_STOP;
      FUNC_AUDIO_STOP;
      FUNC_LCD_BACKLIGTH_ON;
      FUNC_KEYPAD_BACKLIGTH_ON;
      FUNC_LCD_TEST_CARD_1;
   ;;
   
   MAT_KEY_OK_TV)
      FUNC_VIEWFIND_STOP;
      FUNC_AUDIO_STOP;
      FUNC_KEYPAD_BACKLIGTH_ON;
      FUNC_TV_TEST_CARD_1;
   ;;
   
   MAT_KEY_ONHOOK)
      FUNC_AUDIO_STOP;
      FUNC_LCD_BACKLIGTH_ON;
      FUNC_KEYPAD_BACKLIGTH_ON;
      if [ -e /user_data/hw_version.txt ]; then
         ONHOOK_HW_VERSION=`cat /user_data/hw_version.txt`
      else  
         ONHOOK_HW_VERSION=""
      fi
      #tobefix
      ONHOOK_CONFIGURATION_CODE="KPN"
      if [ -e /user_data/prod/test_status.txt ]; then
         ONHOOK_TEST_STATUS=`cat /user_data/prod/test_status.txt`
      else  
         ONHOOK_TEST_STATUS=""
      fi
      printf "HW:$ONHOOK_HW_VERSION;Cfg Code:$ONHOOK_CONFIGURATION_CODE;Teststatus:$ONHOOK_TEST_STATUS\n"
   ;;
   
   MAT_KEY_1)           		#OBIWAN
      FUNC_VIEWFIND_STOP;
      FUNC_AUDIO_STOP;
      FUNC_LCD_BACKLIGTH_ON;
      FUNC_KEYPAD_BACKLIGTH_ON;
      FUNC_RADIO_TX_PACKET_CHANNEL5;
   ;;

   MAT_KEY_2)           		#OBIWAN
         echo "N.A"
   ;;
   
   MAT_KEY_3)                    	#OBIWAN     
     echo "N.A"
   ;;
   
   MAT_KEY_4)              		#OBIWAN
      FUNC_VIEWFIND_STOP;
      FUNC_AUDIO_STOP;
      FUNC_AUDIO_LOOP_MAT;
      FUNC_HP_OFF_MAT;
   ;;
   
   MAT_KEY_5)            		#OBIWAN
      FUNC_VIEWFIND_STOP;
      FUNC_AUDIO_STOP;
      FUNC_LCD_BACKLIGTH_ON;
      FUNC_KEYPAD_BACKLIGTH_ON;
      FUNC_HP_OFF_MAT;

      FILE="/user_data/home/Settings/version.conf"
      if [ -e $FILE ]; then
         P1=`cat $FILE | grep P1`
         P2=`cat $FILE | grep P2`
         P3=`cat $FILE | grep P3`
         P4=`cat $FILE | grep P4`
         P5=`cat $FILE | grep P5`
         P6=`cat $FILE | grep P6`

         printf "$P1 $P2;$P3 $P4;$P5 $P6\n"
      else  
         printf "\n"
      fi
   ;;
   
   MAT_KEY_6)            		#OBIWAN
      printf "Call Nb:;Comm:;Camera:\n"
   ;;
   
   MAT_KEY_7)            		#OBIWAN
      FUNC_VIEWFIND_STOP;
      FUNC_AUDIO_STOP;
      FUNC_LCD_BACKLIGTH_ON;
      FUNC_KEYPAD_BACKLIGTH_ON;
      FUNC_RADIO_GET_MAC_ADDRESS;
      if [ -e /user_data/prod/pn_number.txt ]; then
         JH_NUMBER=`cat /user_data/prod/pn_number.txt`
      else  
         JH_NUMBER=""
      fi
      printf ";JH: $JH_NUMBER\n"
   ;;
   
   MAT_KEY_8)
      echo "N.A"
   ;;
   
   MAT_KEY_9)
      echo "N.A"
   ;;
   
   MAT_KEY_0)
      echo "N.A"
   ;;

   MAT_EXIT_SEQ)
      FUNC_VIEWFIND_STOP;
      FUNC_AUDIO_STOP;
      FUNC_SWITCH_TO_LCD;
   ;;

   #xxxxxxxxxxxxxxxxxxxxxxxx
   SAV_RESET_ALL_PARAM)
      FUNC_VIEWFIND_STOP;
      FUNC_AUDIO_STOP;
      $CONFIG_ATS SAV_RESET_ALL_PARAM;
   ;;

   RESET_ALL_PARAM_WPHBK)
      FUNC_VIEWFIND_STOP;
      FUNC_AUDIO_STOP;
      $CONFIG_ATS FUNC_RESET_ALL_PARAM_WPHBK;
   ;;

   RESET_ALL_PARAM)
      FUNC_VIEWFIND_STOP;
      FUNC_AUDIO_STOP;
      $CONFIG_ATS FUNC_RESET_ALL_PARAM;
   ;;

   RESET_MMI_PARAM)
      FUNC_VIEWFIND_STOP;
      FUNC_AUDIO_STOP;
      $CONFIG_ATS FUNC_RESET_MMI_PARAM;
   ;;


   START_MODE)
      FUNC_START_MODE;
   ;;

#production tests
   OBIWAN_TX_CW_CH10_1MBPS)
      FUNC_TX_CW_CH10_1MBPS;
   ;;
    
   OBIWAN_STOP_FW_MMC)
      FUNC_STOP_FW_MMC;
   ;;

#MAT key 1
   OBIWAN_TX_FAST_PING_1MBPS)
     FUNC_TX_FAST_PING_1MBPS;
   ;;

   TX_FAST_PING_1MBPS)
   FUNC_TX_FAST_PING_1MBPS;
   ;;

#all configuration is done by the CONFIG_ATS script
#get alias   
   GET_NETWORK_INFO)
     #FUNC_GET_NETWORK_INFO;
    $CONFIG_ATS $*;

   ;;

#set alias 
   SET_NETWORK_INFO)
    $CONFIG_ATS $*;
   ;;

   CONFIG_KPN)
    $CONFIG_ATS $*;
   ;;

   CONFIG_EFT1)
    $CONFIG_ATS $*;
   ;;

   CONFIG_EFT2)
    $CONFIG_ATS $*;
   ;;

   CONFIG_FT)
    $CONFIG_ATS $*;
   ;;

   *)
    $CONFIG_ATS $*;
   ;;
esac

