#! /bin/sh
usage(){
        echo "Usage : "
        echo "  eeprom_update.sh -[c,m] <eeprom file> " 
        echo "  -c : customer section to be modified" 
        echo "  -m : manufacturer section to be modified" 
} 

run_pre_test(){
echo "Remove current FW"
echo "rmmod ga_linuxdrv"

dhcpcd -k
killall wpa_supplicant
ifconfig eth0 down
sleep 1
rmmod ga_linuxdrv

echo "Insert MMC FW"
echo "insmod /usr/local/drivers/ga_linuxdrv.o giFWType=1 pu8MACAddr=AABBCCDDEEFF"
insmod /usr/local/drivers/ga_linuxdrv.o giFWType=1 pu8MACAddr=AABBCCDDEEFF
}

run_test(){
echo "Start MMC FW"
echo "/user_data/prod/bin/pctitool "$interface $start_cmd" 255"
/user_data/prod/bin/pctitool $interface $start_cmd 255

echo "Start Update"
echo "/user_data/prod/bin/pctitool "$interface $test_cmd" 255" $mode $append $length 0 $data
echo "File: "$eeprom_file
echo "Content: "$data
/user_data/prod/bin/pctitool $interface $test_cmd 255 $mode $append $length 0 $data
}

display_parameters(){
# Display interface
  echo "Interface="$interface 
}

check_result()
{


cat $eeprom_file  | awk '{print $1}' | cut -d 'x' -f2 | awk '{ printf("0x%s ", $0) }' > /mnt/upgrade/weep
echo "" >> /mnt/upgrade/weep

bin/pctitool  eth0 10 255 1 > /mnt/upgrade/read_eep
tail -n 1 /mnt/upgrade/read_eep | cut -f9- -d ' ' > /mnt/upgrade/reep

diff /mnt/upgrade/weep /mnt/upgrade/reep 

if [ $? -ne 1 ]; then 

  echo "*******************************"
  echo "* EEPROM  UPDATE OK           *"
  echo "*******************************"
else
  echo "*******************************"
  echo "* EEPROM  UPDATE KO !!!!      *"
  echo "*******************************"
  echo "* VERIFICATION IS BAD         *"
  echo "* PLEASE RETRY....            *"
  echo "*******************************"
fi

}


# ************** Start script ************
if [ $# -ne 2 ]; then
      # At least one parameter is missing
      usage
      exit 1
else
  # Get parameters for command line
  mode_cmd=$1
  eeprom_file=$2
fi

if [ "`echo $mode_cmd | cut -b1,2`" = "-c" ]; then 
  echo "Customer section"
  mode=1
else
  if [ "`echo $mode_cmd | cut -b1,2`" = "-m" ]; then 
    echo "Manufacturer section"
    mode=2
  else
      # mode is not correctly selected
      usage
      exit 1
  fi
fi
# prepare driver for test
run_pre_test

# Get current interface
eth_num=`tail -n1 /proc/net/wireless | awk '{print $1}'| cut -b4`
interface='eth'$eth_num

start_cmd='1'
test_cmd=0x0B

# 1 for customer and 2 for manufacturer
#mode=1

# append or overwrite
append=0

length=`wc -l $eeprom_file | cut -c -8`

data=`./eepconverter.sh $eeprom_file`
display_parameters

run_test

check_result

#run_pctitool
                                    
