usage(){
        echo "Option missing .... "
        echo "  auto   : do a scan and select the first access point" 
        echo "  manual : do a scan and ask user to choose the access point" 
        echo ""
        echo "  if no option, get access point essid from /user_data/wifi/iwconfig file" 
} 

update_iwconfig_file(){
echo "rts_threshold="$rts_threshold > /user_data/wifi/iwconfig
echo "listen_bcn_interval="$listen_bcn_interval >> /user_data/wifi/iwconfig
echo "phy_rate="$phy_rate >> /user_data/wifi/iwconfig
echo "country_code="$country_code >> /user_data/wifi/iwconfig
echo "max_time_probe_request="$max_time_probe_request >> /user_data/wifi/iwconfig
}
                               
		   
        ssid=`grep '  ssid=' /user_data/wifi/wpa_supplicant.conf | cut -d "\"" -f2`

	rts_threshold=`grep rts_threshold /user_data/wifi/iwconfig | cut -d "=" -f2`
	if [ "$rts_threshold" = "" ]; then 
		#default rts_threshold
		echo "use default value for rts_threshold"
		rts_threshold=2347
	fi

	max_retry=`grep max_retry /user_data/wifi/iwconfig | cut -d "=" -f2`
	if [ "$max_retry" = "" ]; then 
		#default max_retry
		max_retry=3
	fi

	listen_bcn_interval=`grep listen_bcn_interval /user_data/wifi/iwconfig | cut -d "=" -f2`
	if [ "$listen_bcn_interval" = "" ]; then 
		#default listen_bcn_interval
		listen_bcn_interval=1
	fi

	phy_rate=`grep phy_rate /user_data/wifi/iwconfig | cut -d "=" -f2`
	if [ "$phy_rate" = "" ]; then 
		#default phy_rate
		phy_rate=0
	fi

	country_code=`grep country_code /user_data/wifi/iwconfig | cut -d "=" -f2`
	if [ "$country_code" = "" ]; then 
		#default country_code
		country_code=etsi
	fi

	max_time_probe_request=`grep max_time_probe_request /user_data/wifi/iwconfig | cut -d "=" -f2`
	if [ "$max_time_probe_request" = "" ]; then 
		#default max_time_probe_request
		max_time_probe_request=80
	fi

	update_iwconfig_file				


    #get the wireless ethernet device number                        
    eth_num=`tail -n1 /proc/net/wireless | awk '{print $1}'| cut -b4`

	ifconfig eth$eth_num up

	#set probe request number
    iwpriv eth$eth_num set_scan_tmax $max_time_probe_request
		
	#set beacon listen interval to $listen_bcn_interval
    iwpriv eth$eth_num set_beacon_int $listen_bcn_interval

	#set country code to $country_code
	echo "Set country code may be not implemented yet !!!"
    iwpriv eth$eth_num reg_domain set_$country_code

	#set rate to $phy_rate
    iwconfig eth$eth_num rate $phy_rate     

    #set rate adaptation
    iwpriv eth$eth_num set_lnadp_rates 1000 2000 5500 6000 11000 18000 36000 54000
    iwpriv eth$eth_num set_lnadp_delay 32

    #disable APSD
    iwpriv eth$eth_num qos_parameter set_on_0

                                                                       
        if [ $# -ne 1 ]; then
            param1="config"

			if [ vide$ssid = vide ]; then
				#param1="auto"
				echo "SSID empty !!!"
				echo "Use option auto or manual to fill this field"
				exit 1
			fi
		else
	           param1=$1

        fi

                
        echo "${param1} mode ...."
                
        case $param1 in
                
            #get the SSID of the first access point in the range            
            "auto" ) ssid=`iwlist eth$eth_num scan | grep ESSID | cut -d"\"" -f2 | head -n1` ;;

            #get the SSID from user 
            "manual" )  iwlist eth$eth_num scan | grep ESSID | cut -d"\"" -f2
                        echo "Enter the choosen SSID :"
                        read ssid;;

            #get the SSID from config file
            "config" )
                        ssid=`grep '  ssid=' /user_data/wifi/wpa_supplicant.conf | cut -d "\"" -f2`;; 

            * ) echo "invalid option ..."
                        usage 
                        exit 1;;
        esac

        #set rts threshold value                          
        iwconfig eth$eth_num rts $rts_threshold                         

        #save the access point essid in /user_data/wifi/iwconfig
		if [ "$param1" != "config" ]; then				
			update_iwconfig_file
		fi
     
